/***************************************************************************
                          tea_gtk_utils.c  -  description
                             -------------------
    begin                : aug. 2004
    copyright            : (C) 2004 by Peter 'Roxton' Semiletov
    email                : tea@list.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


#include <glib.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <sys/stat.h>
#include <gdk/gdkkeysyms.h>
//
#include <stddef.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
//
#include "tea_defs.h"
#include "tea_options.h"
#include "tea_gtk_utils.h"
#include "tea_config.h"



static void on_kwas_notebook_switch_page (GtkNotebook *notebook,
                                          GtkNotebookPage *page,
                                          guint page_num,
                                          gpointer user_data)
{
  confile.last_prefs_tab = page_num;      
}


static void cb_on_bt_apply (GtkObject *object, GtkWidget *w) 
{
   GList *l = NULL;





   l = add_to_glist_combined_str (l, "fmt_color_function", gtk_entry_get_text (GTK_ENTRY (ent_fmt_color_function)));


   l = add_to_glist_combined_str (l, "def_save_dir", gtk_entry_get_text (GTK_ENTRY (ent_def_save_dir)));
   l = add_to_glist_combined_str (l, "def_open_dir", gtk_entry_get_text (GTK_ENTRY (ent_def_open_dir)));

   l = add_to_glist_combined_str (l, "cm_mplayer", gtk_entry_get_text (GTK_ENTRY (ent_cm_mplayer)));
   l = add_to_glist_combined_str (l, "cm_mozilla", gtk_entry_get_text (GTK_ENTRY (ent_cm_mozilla)));
   l = add_to_glist_combined_str (l, "cm_konqueror", gtk_entry_get_text (GTK_ENTRY (ent_cm_konqueror)));
   l = add_to_glist_combined_str (l, "cm_firefox", gtk_entry_get_text (GTK_ENTRY (ent_cm_firefox)));
   l = add_to_glist_combined_str (l, "cm_opera", gtk_entry_get_text (GTK_ENTRY (ent_cm_opera)));
   l = add_to_glist_combined_str (l, "cm_links", gtk_entry_get_text (GTK_ENTRY (ent_cm_links)));
   l = add_to_glist_combined_str (l, "cm_elinks", gtk_entry_get_text (GTK_ENTRY (ent_cm_elinks)));
   l = add_to_glist_combined_str (l, "cm_dillo", gtk_entry_get_text (GTK_ENTRY (ent_cm_dillo)));
   l = add_to_glist_combined_str (l, "cm_galeon", gtk_entry_get_text (GTK_ENTRY (ent_cm_galeon)));
   l = add_to_glist_combined_str (l, "cm_epiphany", gtk_entry_get_text (GTK_ENTRY (ent_cm_epiphany)));

   l = add_to_glist_combined_str (l, "cm_other", gtk_entry_get_text (GTK_ENTRY (ent_cm_other)));
   l = add_to_glist_combined_str (l, "cm_lynx", gtk_entry_get_text (GTK_ENTRY (ent_cm_lynx)));
   l = add_to_glist_combined_str (l, "def_doc_browser", gtk_entry_get_text (GTK_ENTRY (ent_cm_manual_browser)));

   l = add_to_glist_combined_str (l, "date_time", gtk_entry_get_text (GTK_ENTRY (ent_date_time)));

   l = add_to_glist_combined_str (l, "tag_comment", gtk_entry_get_text (GTK_ENTRY (ent_tag_comment)));
   l = add_to_glist_combined_str (l, "tag_identifier", gtk_entry_get_text (GTK_ENTRY (ent_tag_identifier)));
   l = add_to_glist_combined_str (l, "tag_digit", gtk_entry_get_text (GTK_ENTRY (ent_tag_digit)));
   l = add_to_glist_combined_str (l, "tag_string", gtk_entry_get_text (GTK_ENTRY (ent_tag_string)));
   l = add_to_glist_combined_str (l, "tag_html_tag", gtk_entry_get_text (GTK_ENTRY (ent_tag_html_tag)));

   l = add_to_glist_combined_str (l, "tag_preprocessor", gtk_entry_get_text (GTK_ENTRY (ent_tag_preprocessor)));
   l = add_to_glist_combined_str (l, "tag_type", gtk_entry_get_text (GTK_ENTRY (ent_tag_type)));
   l = add_to_glist_combined_str (l, "tag_spellcheck", gtk_entry_get_text (GTK_ENTRY (ent_tag_spellcheck)));

   l = add_to_glist_combined_str (l, "text_foreground", gtk_entry_get_text (GTK_ENTRY (ent_text_foreground)));
   l = add_to_glist_combined_str (l, "text_background", gtk_entry_get_text (GTK_ENTRY (ent_text_background)));
 
   l = add_to_glist_combined_str (l, "text_sel_foreground", gtk_entry_get_text (GTK_ENTRY (ent_text_sel_foreground)));
   l = add_to_glist_combined_str (l, "text_sel_background", gtk_entry_get_text (GTK_ENTRY (ent_text_sel_background)));

   l = add_to_glist_combined_str (l, "rtf_enc", gtk_entry_get_text (GTK_ENTRY (ent_rtf_enc)));
   l = add_to_glist_combined_str (l, "tag_comment_font", gtk_entry_get_text (GTK_ENTRY (ent_tag_comment_font)));

   l = add_to_glist_combined_str (l, "tag_identifier_font", gtk_entry_get_text (GTK_ENTRY (ent_tag_identifier_font)));
   l = add_to_glist_combined_str (l, "tag_digit_font", gtk_entry_get_text (GTK_ENTRY (ent_tag_digit_font)));

   l = add_to_glist_combined_str (l, "tag_string_font", gtk_entry_get_text (GTK_ENTRY (ent_tag_string_font)));
   l = add_to_glist_combined_str (l, "tag_html_tag_font", gtk_entry_get_text (GTK_ENTRY (ent_tag_html_tag_font)));

   l = add_to_glist_combined_str (l, "tag_preprocessor_font", gtk_entry_get_text (GTK_ENTRY (ent_tag_preprocessor_font)));
   l = add_to_glist_combined_str (l, "tag_type_font", gtk_entry_get_text (GTK_ENTRY (ent_tag_type_font)));

   l = add_to_glist_combined_str (l, "editor_font", gtk_entry_get_text (GTK_ENTRY (ent_editor_font)));
   l = add_to_glist_combined_str (l, "ext_pic_editor", gtk_entry_get_text (GTK_ENTRY (ent_ext_pic_editor)));
   l = add_to_glist_combined_str (l, "ext_pic_viewer", gtk_entry_get_text (GTK_ENTRY (ent_ext_pic_viewer)));


   l = add_to_glist_combined_bool (l, "xhtml_mode", gtk_toggle_button_get_active (&cb_xhtml_mode->toggle_button));
   l = add_to_glist_combined_bool (l, "use_snippets", gtk_toggle_button_get_active (&cb_use_snippets->toggle_button));
   l = add_to_glist_combined_bool (l, "use_ext_image_viewer", gtk_toggle_button_get_active (&cb_use_ext_image_viewer->toggle_button));

   l = add_to_glist_combined_bool (l, "do_hl_on_fileopen", gtk_toggle_button_get_active (&cb_do_hl_on_fileopen->toggle_button));
   l = add_to_glist_combined_bool (l, "do_backup", gtk_toggle_button_get_active (&cb_do_backup->toggle_button));

   l = add_to_glist_combined_bool (l, "do_enc_autodetect", gtk_toggle_button_get_active (&cb_do_enc_autodetect->toggle_button));
   l = add_to_glist_combined_bool (l, "use_def_doc_browser", gtk_toggle_button_get_active (&cb_use_def_doc_browser->toggle_button));

   l = add_to_glist_combined_bool (l, "show_line_nums", gtk_toggle_button_get_active (&cb_show_line_nums->toggle_button));
   l = add_to_glist_combined_bool (l, "word_wrap", gtk_toggle_button_get_active (&cb_word_wrap->toggle_button));
   //l = add_to_glist_combined_bool (l, "use_autocomp", gtk_toggle_button_get_active (&cb_use_autocomp->toggle_button));
   l = add_to_glist_combined_bool (l, "use_def_save_dir", gtk_toggle_button_get_active (&cb_use_def_save_dir->toggle_button));
   l = add_to_glist_combined_bool (l, "use_def_open_dir", gtk_toggle_button_get_active (&cb_use_def_open_dir->toggle_button));
   l = add_to_glist_combined_bool (l, "use_auto_indent", gtk_toggle_button_get_active (&cb_use_auto_indent->toggle_button));
  

   l = add_to_glist_combined_bool (l, "ins_spaces_on_tab_press", gtk_toggle_button_get_active (&cb_ins_spaces_on_tab_press->toggle_button));
   l = add_to_glist_combined_bool (l, "scan_for_links_on_doc_open", gtk_toggle_button_get_active (&cb_scan_for_links_on_doc_open->toggle_button));
   l = add_to_glist_combined_bool (l, "main_wnd_show_full_path", gtk_toggle_button_get_active (&cb_main_wnd_show_full_path->toggle_button));
/*
   l = add_to_glist_combined_bool (l, "enc_det_shift_jis", gtk_toggle_button_get_active (&cb_enc_det_shift_jis->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_euc_jp", gtk_toggle_button_get_active (&cb_enc_det_euc_jp->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_gb18030", gtk_toggle_button_get_active (&cb_enc_det_gb18030->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_big5", gtk_toggle_button_get_active (&cb_enc_det_big5->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_iso_2022_jp", gtk_toggle_button_get_active (&cb_enc_det_iso_2022_jp->toggle_button));
*/

   l = add_to_glist_combined_bool (l, "enc_det_cp1251", gtk_toggle_button_get_active (&cb_enc_det_cp1251->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_koi8r", gtk_toggle_button_get_active (&cb_enc_det_koi8r->toggle_button));

   l = add_to_glist_combined_bool (l, "enc_det_koi8u", gtk_toggle_button_get_active (&cb_enc_det_koi8u->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_866", gtk_toggle_button_get_active (&cb_enc_det_866->toggle_button));

   l = add_to_glist_combined_bool (l, "enc_det_finnish", gtk_toggle_button_get_active (&cb_enc_det_finnish->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_german", gtk_toggle_button_get_active (&cb_enc_det_german->toggle_button));

   l = add_to_glist_combined_bool (l, "enc_det_serbian", gtk_toggle_button_get_active (&cb_enc_det_serbian->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_latvian", gtk_toggle_button_get_active (&cb_enc_det_latvian->toggle_button));

   l = add_to_glist_combined_bool (l, "enc_det_polish", gtk_toggle_button_get_active (&cb_enc_det_polish->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_portuguese", gtk_toggle_button_get_active (&cb_enc_det_portuguese->toggle_button));

   l = add_to_glist_combined_bool (l, "enc_det_slovak", gtk_toggle_button_get_active (&cb_enc_det_slovak->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_slovenian", gtk_toggle_button_get_active (&cb_enc_det_slovenian->toggle_button));

   l = add_to_glist_combined_bool (l, "enc_det_spanish", gtk_toggle_button_get_active (&cb_enc_det_spanish->toggle_button));
   l = add_to_glist_combined_bool (l, "enc_det_turkish", gtk_toggle_button_get_active (&cb_enc_det_turkish->toggle_button));

   l = add_to_glist_combined_bool (l, "kwas_show_hidden_files", gtk_toggle_button_get_active (&cb_kwas_show_hidden_files->toggle_button));
   l = add_to_glist_combined_bool (l, "do_autorep", gtk_toggle_button_get_active (&cb_do_autorep->toggle_button));



   l = add_to_glist_combined_int (l, "logmemo_lines_max", gtk_spin_button_get_value_as_int (sb_logmemo_lines_max));  
   l = add_to_glist_combined_int (l, "famous_history_max", gtk_spin_button_get_value_as_int (sb_famous_history_max));  
   l = add_to_glist_combined_int (l, "max_recent_items", gtk_spin_button_get_value_as_int (sb_max_recent_items));  
   //l = add_to_glist_combined_int (l, "autocomp_wordlen_min", gtk_spin_button_get_value_as_int (sb_autocomp_wordlen_min));  
   //l = add_to_glist_combined_int (l, "autocomp_list_items_max", gtk_spin_button_get_value_as_int (sb_autocomp_list_items_max));  

   l = add_to_glist_combined_int (l, "saveopen_w", gtk_spin_button_get_value_as_int (sb_saveopen_w));  
   l = add_to_glist_combined_int (l, "saveopen_h", gtk_spin_button_get_value_as_int (sb_saveopen_h));  
   l = add_to_glist_combined_int (l, "tab_size", gtk_spin_button_get_value_as_int (sb_tab_size));  
 
   glist_save_to_file (l, confile.tea_rc);

   glist_strings_free (l);
   confile_reload ();
}


static void cb_on_bt_close (GtkObject *object, GtkWidget *w) 
{
  window_destroy (w);
}


static GtkWidget* wnd_options_encoding (void)
{
  GtkWidget *wnd = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (wnd);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (wnd), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);
  gtk_scrolled_window_add_with_viewport (wnd, page);

  GtkWidget *fr1 = gtk_frame_new (_("Misc"));   
  gtk_widget_show (fr1);
 
  gtk_box_pack_start (page, fr1, FALSE, FALSE, 1);
  cb_do_enc_autodetect = tea_checkbox (page, _("Do encoding autodetect"), confile.do_enc_autodetect);
  
  ent_rtf_enc = tea_text_entry (page, _("Default charset for RTF"), confile.rtf_enc);  
 
  GtkWidget *fr2 = gtk_frame_new (_("Autodetect"));   
  gtk_widget_show (fr2);
 
  gtk_box_pack_start (page, fr2, FALSE, FALSE, 1);
  
  cb_enc_det_cp1251 = tea_checkbox (page, _("CP 1251"), confile.enc_det_cp1251); 
  cb_enc_det_koi8r = tea_checkbox (page, _("KOI8-R"), confile.enc_det_koi8r);
  cb_enc_det_koi8u = tea_checkbox (page, _("KOI8-U"), confile.enc_det_koi8u);
  cb_enc_det_866 = tea_checkbox (page, _("DOS 866"), confile.enc_det_866);


//  cb_enc_det_shift_jis = tea_checkbox (page, _("Shift JIS"), confile.enc_det_shift_jis); 
//  cb_enc_det_euc_jp = tea_checkbox (page, _("EUC-JP"), confile.enc_det_euc_jp);
//  cb_enc_det_iso_2022_jp = tea_checkbox (page, _("ISO 2022 JP"), confile.enc_det_iso_2022_jp);

//  cb_enc_det_gb18030 = tea_checkbox (page, _("GB19030"), confile.enc_det_gb18030);
//  cb_enc_det_big5 = tea_checkbox (page, _("BIG5"), confile.enc_det_big5);

  cb_enc_det_finnish = tea_checkbox (page, _("Finnish"), confile.enc_det_finnish);
  cb_enc_det_german = tea_checkbox (page, _("German"), confile.enc_det_german);
  cb_enc_det_serbian = tea_checkbox (page, _("Serbian"), confile.enc_det_serbian);
  cb_enc_det_latvian = tea_checkbox (page, _("Latvian"), confile.enc_det_latvian);
  cb_enc_det_polish = tea_checkbox (page, _("Polish"), confile.enc_det_polish);
  cb_enc_det_portuguese = tea_checkbox (page, _("Portuguese"), confile.enc_det_portuguese);
  cb_enc_det_slovak = tea_checkbox (page, _("Slovak"), confile.enc_det_slovak);
  cb_enc_det_slovenian = tea_checkbox (page, _("Slovenian"), confile.enc_det_slovenian);
  cb_enc_det_spanish = tea_checkbox (page, _("Spanish"), confile.enc_det_spanish);  
  cb_enc_det_turkish = tea_checkbox (page, _("Turkish"), confile.enc_det_turkish);  

  return wnd;
}


static GtkWidget* wnd_options_commands (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);

  ent_ext_pic_editor = tea_text_entry (page, _("External image editor"), confile.ext_pic_editor);
  ent_ext_pic_viewer = tea_text_entry (page, _("External image viewer"), confile.ext_pic_viewer);
  ent_cm_mplayer =  tea_text_entry (page, _("Run Mplayer with subtitles"), confile.cm_mplayer);
 
  return page;
}

/*
static GtkWidget* wnd_options_hotkeys (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);

  ent_hotkey = tea_text_entry (page, _("Hotkey"), "F1");

  gtk_signal_connect (GTK_OBJECT (ent_hotkey), "key_press_event",
                      GTK_SIGNAL_FUNC (on_enthotkey_press_event),
                      NULL);
 
  return page;
}
*/

static GtkWidget* wnd_options_limits (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);

  sb_logmemo_lines_max = tea_spinbutton (page, _("Logmemo lines limit"), confile.logmemo_lines_max);
  sb_famous_history_max = tea_spinbutton (page, _("Text entry history limit"), confile.famous_history_max);
  sb_max_recent_items = tea_spinbutton (page, _("Max. recent files"), confile.max_recent_items); 

  return page;
}


static GtkWidget* wnd_options_functions (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);
  ent_date_time = tea_text_entry (page, _("Date and time format"), confile.date_time);
  ent_fmt_color_function = tea_text_entry (page, _("The format of the Color function"), confile.fmt_color_function);

  return page;
}


static GtkWidget* wnd_options_interface (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);
  
  sb_saveopen_w = tea_spinbutton (page, _("Save/Open dialogs width per cents"), confile.saveopen_w);
  sb_saveopen_h = tea_spinbutton (page, _("Save/Open dialogs height per cents"), confile.saveopen_h);

  cb_main_wnd_show_full_path = tea_checkbox (page, _("Show the full path in the window caption"), confile.main_wnd_show_full_path); 

  return page;
}


static GtkWidget* wnd_options_switches (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);

  cb_xhtml_mode = tea_checkbox (page, _("XHTML mode for Markup stuff"), confile.xhtml_mode); 
  cb_kwas_show_hidden_files = tea_checkbox (page, _("Show hidden files in Kwas"), confile.kwas_show_hidden_files); 
  cb_use_snippets = tea_checkbox (page, _("Use snippets"), confile.use_snippets); 
  cb_use_ext_image_viewer = tea_checkbox (page, _("Use external image viewer"), confile.use_ext_image_viewer);
  cb_do_hl_on_fileopen = tea_checkbox (page, _("Highlight on file open"), confile.do_hl_on_fileopen);
  cb_do_backup = tea_checkbox (page, _("Do backup"), confile.do_backup);
  cb_show_line_nums = tea_checkbox (page, _("Show line numbers"), confile.show_line_nums);
  cb_word_wrap = tea_checkbox (page, _("Word wrap"), confile.word_wrap);
  
  cb_scan_for_links_on_doc_open = tea_checkbox (page, _("Scan for links on file open"), confile.scan_for_links_on_doc_open);

  return page;
}


static GtkWidget* wnd_options_colors (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);

  ent_text_foreground = tea_color_selector (page, _("Text foreground"), confile.text_foreground);
  ent_text_background = tea_color_selector (page, _("Text background"), confile.text_background);
  ent_text_sel_foreground = tea_color_selector (page, _("Selected foreground"), confile.text_sel_foreground);
  ent_text_sel_background = tea_color_selector (page, _("Selected background"), confile.text_sel_background);
  ent_tag_spellcheck = tea_color_selector (page, _("Spellcheker marks"), confile.tag_spellcheck);
  
  ent_tag_comment = tea_color_selector (page, _("Comments"), confile.tag_comment);
  ent_tag_identifier = tea_color_selector (page, _("Identifiers"), confile.tag_identifier);
  ent_tag_digit = tea_color_selector (page, _("Digits"), confile.tag_digit); 
  ent_tag_string = tea_color_selector (page, _("Strings"), confile.tag_string);
  ent_tag_html_tag = tea_color_selector (page, _("HTML tags"), confile.tag_html_tag);
  ent_tag_preprocessor = tea_color_selector (page, _("Preprocessor"), confile.tag_preprocessor);
  ent_tag_type = tea_color_selector (page, _("Types"), confile.tag_type);

  return page;
}


static GtkWidget* wnd_options_fonts (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);

  ent_editor_font = tea_font_selector (page, _("Editor font"), confile.editor_font); 

  ent_tag_comment_font = tea_font_selector (page, _("Comments font"), confile.tag_comment_font); 
  ent_tag_identifier_font = tea_font_selector (page, _("Identifiers font"), confile.tag_identifier_font); 
  ent_tag_digit_font = tea_font_selector (page, _("Digits font"), confile.tag_digit_font); 
  ent_tag_string_font = tea_font_selector (page, _("Strings font"), confile.tag_string_font); 
  ent_tag_html_tag_font = tea_font_selector (page, _("HTML tags font"), confile.tag_html_tag_font); 
  ent_tag_preprocessor_font = tea_font_selector (page, _("Preprocessor font"), confile.tag_preprocessor_font); 
  ent_tag_type_font = tea_font_selector (page, _("Types font"), confile.tag_type_font); 
  
  return page;
}


static GtkWidget* wnd_options_browsers (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);
  ent_cm_opera = tea_text_entry (page, "Opera", confile.cmd_Opera);
  ent_cm_konqueror = tea_text_entry (page, "Konqueror", confile.cmd_Konqueror);
  ent_cm_firefox = tea_text_entry (page, "Firefox", confile.cmd_Firefox);
  ent_cm_mozilla = tea_text_entry (page, "Mozilla",  confile.cmd_Mozilla);
  ent_cm_links = tea_text_entry (page, "Links", confile.cmd_Links); 
  ent_cm_elinks = tea_text_entry (page, "Elinks", confile.cmd_ELinks);
  ent_cm_dillo = tea_text_entry (page, "Dillo", confile.cmd_Dillo);
  ent_cm_galeon = tea_text_entry (page, "Galeon", confile.cmd_Galeon);
  ent_cm_epiphany = tea_text_entry (page, "Epiphany", confile.cmd_Epiphany); 
  ent_cm_other = tea_text_entry (page, "Other", confile.cmd_Other);
  ent_cm_lynx = tea_text_entry (page, "Lynx", confile.cmd_Lynx);
  ent_cm_manual_browser = tea_text_entry (page, _("Browser for the manual"), confile.cmd_def_doc_browser);
  cb_use_def_doc_browser = tea_checkbox (page, _("Use this browser"), confile.use_def_doc_browser); 

  return page;
}


static GtkWidget* wnd_options_editor (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);
  sb_tab_size = tea_spinbutton (page, _("Tab size in spaces"), confile.tab_size);
  cb_ins_spaces_on_tab_press = tea_checkbox (page, _("Insert spaces on TAB key"), confile.ins_spaces_on_tab_press);
  cb_use_auto_indent = tea_checkbox (page, _("Automatic indent"), confile.use_auto_indent);


  return page;
}


static GtkWidget* wnd_options_paths (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);
  //ent_def_save_dir = tea_text_entry (page, _("Default file saving directory"), confile.def_save_dir);
  ent_def_save_dir = tea_dir_selector (page, _("Default file saving directory"), confile.def_save_dir);
  cb_use_def_save_dir = tea_checkbox (page, _("Use default saving directory"), confile.use_def_save_dir);

  ent_def_open_dir = tea_dir_selector (page, _("Default file opening directory"), confile.def_open_dir);
  cb_use_def_open_dir = tea_checkbox (page, _("Use default file opening directory"), confile.use_def_open_dir);
  
  return page;
}


static GtkWidget* wnd_options_coauthor (void)
{
  GtkWidget *page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (page);


  //cb_use_autocomp = tea_checkbox (page, _("Automatic word completion"), confile.use_autocomp);
  //sb_autocomp_wordlen_min = tea_spinbutton (page, _("Mininum autocompletion word length"), confile.autocomp_wordlen_min);
  //sb_autocomp_list_items_max = tea_spinbutton (page, _("Autocompletion list items maximum"), confile.autocomp_list_items_max);
  cb_do_autorep = tea_checkbox (page, _("Autoreplace"), confile.do_autorep);
  return page;
}



GtkWidget* wnd_options_create (void)
{
  GtkWidget *wnd = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  gtk_window_set_title (GTK_WINDOW (wnd), _("Options, I presume..."));

  GtkWidget *vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (wnd), vbox1);

  GtkWidget *notebook = gtk_notebook_new ();         
  gtk_notebook_set_tab_pos (notebook, GTK_POS_LEFT);

  gtk_widget_show (notebook);

  gtk_container_add (GTK_CONTAINER (vbox1), notebook);

  //gtk_notebook_append_page (notebook, wnd_options_hotkeys (), gtk_label_new (_("Hotkeys")));
  gtk_notebook_append_page (notebook, wnd_options_switches (), gtk_label_new (_("Switches")));
  gtk_notebook_append_page (notebook, wnd_options_encoding (), gtk_label_new (_("Encoding")));
  gtk_notebook_append_page (notebook, wnd_options_functions (), gtk_label_new (_("Functions")));
  gtk_notebook_append_page (notebook, wnd_options_interface (), gtk_label_new (_("Interface")));
  gtk_notebook_append_page (notebook, wnd_options_limits (), gtk_label_new (_("Limits")));
  gtk_notebook_append_page (notebook, wnd_options_fonts (), gtk_label_new (_("Fonts")));
  gtk_notebook_append_page (notebook, wnd_options_editor (), gtk_label_new (_("Editor")));
  gtk_notebook_append_page (notebook, wnd_options_browsers (), gtk_label_new (_("Browsers")));
  gtk_notebook_append_page (notebook, wnd_options_colors (), gtk_label_new (_("Colors")));
  gtk_notebook_append_page (notebook, wnd_options_commands (), gtk_label_new (_("Commands")));
  gtk_notebook_append_page (notebook, wnd_options_paths (), gtk_label_new (_("Paths")));
  gtk_notebook_append_page (notebook, wnd_options_coauthor (), gtk_label_new (_("Co-author")));



  gtk_notebook_set_current_page (notebook, confile.last_prefs_tab);

  g_signal_connect ((gpointer) notebook, "switch_page",
                    G_CALLBACK (on_kwas_notebook_switch_page),
                    NULL);

  GtkWidget *hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (vbox1), hbox1);

  GtkWidget *bt_close = gtk_button_new_with_label (_("Close"));
  gtk_widget_show (bt_close);
  gtk_container_add (GTK_CONTAINER (hbox1), bt_close);
  g_signal_connect (bt_close, "clicked", G_CALLBACK (cb_on_bt_close), wnd);

  GtkWidget *bt_apply = gtk_button_new_with_label (_("Save and apply"));
  gtk_widget_show (bt_apply);
  gtk_container_add (GTK_CONTAINER (hbox1), bt_apply);
  g_signal_connect (bt_apply, "clicked", G_CALLBACK (cb_on_bt_apply), wnd);

  gtk_window_set_position (wnd, GTK_WIN_POS_CENTER);   
  gtk_window_set_modal (wnd, TRUE);

  gtk_widget_show (wnd);
  return wnd;

}

